Mac OS X Build Instructions and Notes
====================================

The commands in this guide should be executed in a Terminal application.
The built-in one is located in `/Applications/Utilities/Terminal.app`.

Preparation
-----------

Install the OS X command line tools:

`xcode-select --install`

When the popup appears, click `Install`.

Then install [Homebrew](https://brew.sh).

Base build dependencies
-----------------------

```bash
brew install automake libtool pkg-config
```

If you want to build the disk image with `make deploy` (.dmg / optional), you need RSVG

```bash
brew install librsvg
```

Building
--------

Follow the instructions in [build-generic](build-generic.md)

Running
-------

Ion Core is now available at `./src/iond`

Before running, it's recommended you create an RPC configuration file.

```bash
echo -e "rpcuser=ionrpc\nrpcpassword=$(xxd -l 16 -p /dev/urandom)" > "/Users/${USER}/Library/Application Support/ioncoin/ioncoin.conf"

chmod 600 "/Users/${USER}/Library/Application Support/ioncoin/ioncoin.conf"
```

The first time you run iond, it will start downloading the blockchain. This process could take several hours.

You can monitor the download process by looking at the debug.log file:

```bash
tail -f $HOME/Library/Application\ Support/ioncoin/debug.log
```

Other commands
-------

```bash
./src/iond -daemon # Starts the ion daemon.
./src/ion-cli --help # Outputs a list of command-line options.
./src/ion-cli help # Outputs a list of RPC commands when the daemon is running.
```

Using Qt Creator as IDE
------------------------

You can use Qt Creator as an IDE, for ion development.
Download and install the community edition of [Qt Creator](https://www.qt.io/download/).
Uncheck everything except Qt Creator during the installation process.

1. Make sure you installed everything through Homebrew mentioned above
2. Do a proper ./configure --enable-debug
3. In Qt Creator do "New Project" -> Import Project -> Import Existing Project
4. Enter "ion-qt" as project name, enter src/qt as location
5. Leave the file selection as it is
6. Confirm the "summary page"
7. In the "Projects" tab select "Manage Kits..."
8. Select the default "Desktop" kit and select "Clang (x86 64bit in /usr/bin)" as compiler
9. Select LLDB as debugger (you might need to set the path to your installation)
10. Start debugging with Qt Creator
